// PC-8801MA2 Xf (PC88) ADPCMf[^Jb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x40000];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[] = "ADPCM";
	int i,tr;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x1a);
	tr = 0x48;
	for (i=0; i<(0x40000/0x1a00); i++) {
		disk.ReadDATA(tr, tr>>1, tr&1, 1, 1, &buff[i*0x1a00], 0x1a00);
		tr += 2;
	}
	printf ("cutting ... %s\n",fname);
	fp = fopen(fname,"wb");
	fwrite(buff, 1, sizeof(buff), fp);
	fclose(fp);

	return 0;
}

